package expr

const (
	Unknown uint8 = iota
	String
	Int
	Float
)

func init() {
	RegisterOption(
		Extend("In", In),
	)
}

func In(v1, v2 interface{}) bool {
	if v1 == nil || v2 == nil {
		return false
	}

	s1, ok1 := v1.([]interface{})
	s2, ok2 := v2.([]interface{})

	switch {
	case ok1 && ok2:
		return sliceInSlice1(s1, s2)
	case ok1 && !ok2:
		return valueInSlice1(v2, s1)
	case !ok1 && ok2:
		return valueInSlice1(v1, s2)
	case !ok1 && !ok2:
		return v1 == v2
	}

	return false
}

func sliceInSlice1(s1, s2 []interface{}) bool {
	for _, v1 := range s1 {
		if valueInSlice1(v1, s2) {
			return true
		}
	}
	return false
}

func valueInSlice1(v interface{}, s []interface{}) bool {
	for _, e := range s {
		if e == v {
			return true
		}
	}
	return false
}
